SystemOrganization addCategory: #tp1!
SystemOrganization addCategory: #Tp1!
SystemOrganization addCategory: #'Tp1-Test'!
SystemOrganization addCategory: #'Tp1-Tests'!

Trait named: #Agenda
	uses: {}
	category: 'Tp1'!

!Agenda methodsFor: 'TraitAgenda' stamp: 'macha 9/13/2013 23:51'!
agendaDeEventos

	| listaDeEventos |
	
	listaDeEventos := OrderedCollection new.

	(self grupos) do: [ :unGrupo | (unGrupo dameTusEventos: self) do: [ :unEvento | listaDeEventos add: unEvento] ].
	
	
	^ listaDeEventos.

! !

!Agenda methodsFor: 'Requirements' stamp: 'JulianGalati 9/13/2013 12:28'!
grupos 

	self requiredMethods.! !

Trait named: #EstadisticasCore
	uses: {}
	category: 'Tp1'!

!EstadisticasCore methodsFor: 'Trait-EstadisticasCore-Domain' stamp: 'RamiroMachado 10/5/2013 02:05'!
cantidadDeAbandonadas: cursadas

	^ (self filtrarAbandono:  cursadas) size.! !

!EstadisticasCore methodsFor: 'Trait-EstadisticasCore-Domain' stamp: 'RamiroMachado 10/5/2013 02:06'!
cantidadDeAprobadas: cursadas

	^ (self filtrarAprobados: cursadas) size.! !

!EstadisticasCore methodsFor: 'Trait-EstadisticasCore-Domain' stamp: 'RamiroMachado 10/5/2013 02:09'!
cuantasNotasCon: unaNota deEstasCursadas: cursadas


	^((self filtrarPresentes: cursadas) select: [ :cadaCursada | (cadaCursada nota) = unaNota ]) size.! !

!EstadisticasCore methodsFor: 'Trait-EstadisticasCore-Domain' stamp: 'RamiroMachado 10/5/2013 02:09'!
cuantasNotasMayorOIgual: unaNota deEstasCursadas: cursadas


	^((self filtrarPresentes: cursadas)  select: [ :cadaCursada | (cadaCursada nota) >= unaNota ]) size.! !

!EstadisticasCore methodsFor: 'Trait-EstadisticasCore-Filtros' stamp: 'RamiroMachado 10/5/2013 02:09'!
filtrarAbandono: unaColeccionDeCursadas

	^ (unaColeccionDeCursadas select: [ :unaCursada | (unaCursada terminasteLaCursada) not]).
	! !

!EstadisticasCore methodsFor: 'Trait-EstadisticasCore-Filtros' stamp: 'RamiroMachado 10/5/2013 02:09'!
filtrarAprobados: unaColeccionDeCursadas

	^ (unaColeccionDeCursadas select: [ :unaCursada| (unaCursada terminasteLaCursada) and: [unaCursada estasAprobada]]).
	! !

!EstadisticasCore methodsFor: 'Trait-EstadisticasCore-Filtros' stamp: 'RamiroMachado 10/5/2013 02:09'!
filtrarDesaprobados: unaColeccionDeCursadas

	^ (unaColeccionDeCursadas select: [ :unaCursada| ((unaCursada terminasteLaCursada) and: [(unaCursada estasAprobada) not])]).! !

!EstadisticasCore methodsFor: 'Trait-EstadisticasCore-Filtros' stamp: 'RamiroMachado 10/5/2013 02:08'!
filtrarPresentes: unaColeccionDeCursadas

	^ (unaColeccionDeCursadas select: [ :unaCursada | (unaCursada terminasteLaCursada)]).! !

!EstadisticasCore methodsFor: 'Trait-EstadisticasCore-Domain' stamp: 'RamiroMachado 10/5/2013 02:08'!
notaMasAltaNVeces: nVeces deEstasCursadas: cursadas

	
	| colecciontemp |
	colecciontemp := {10. 9. 8. 7. 6. 5. 4. 3. 2. 1. 0}.


	colecciontemp do:[ :unaNota | ( (self cuantasNotasMayorOIgual: unaNota deEstasCursadas: cursadas) >= nVeces ) ifTrue: [ ^ unaNota  ] ifFalse: [unaNota  = 0 ifTrue: [^ 'No habia notas suficientes']  ] ]. ! !

!EstadisticasCore methodsFor: 'Trait-EstadisticasCore-Domain' stamp: 'RamiroMachado 10/5/2013 02:07'!
porcentajeDeAprobadosSobreIniciados: cursadas

	^ ((self cantidadDeAprobadas: cursadas ) /  (cursadas size) ) * 100! !

!EstadisticasCore methodsFor: 'Trait-EstadisticasCore-Domain' stamp: 'RamiroMachado 10/5/2013 02:07'!
promedioConAplazos: cursadas

	|notas|
	
	notas := Bag new.

	((self filtrarPresentes:  cursadas ) do: [:unaCursada | notas add: (unaCursada nota)]).

	^notas average.! !

!EstadisticasCore methodsFor: 'Trait-EstadisticasCore-Domain' stamp: 'RamiroMachado 10/5/2013 02:07'!
promedioSinAplazos: cursadas

	|notas|
	
	notas := Bag new.
	
	((self filtrarAprobados: cursadas)  do: [:unaCursada | notas add: (unaCursada nota)]).
	
	^notas average.! !

!EstadisticasCore methodsFor: 'Trait-EstadisticasCore-Domain' stamp: 'RamiroMachado 10/5/2013 02:07'!
tablaNotas: cursadas
	|colecciontemp coleccionReturn |

	colecciontemp := {0. 1. 2. 3. 4. 5. 6. 7. 8. 9. 10}.
	coleccionReturn := Dictionary  new.
	colecciontemp 	do: [ :x |  coleccionReturn at: x put: (self cuantasNotasCon: x deEstasCursadas: cursadas)].
	^coleccionReturn! !

Trait named: #EstadisticasPorAnio
	uses: {}
	category: 'Tp1'!

!EstadisticasPorAnio methodsFor: 'Requirements' stamp: 'RamiroMachado 10/5/2013 02:16'!
cantidadDeAbandonadas: unAnio

	self requiredMethods.! !

!EstadisticasPorAnio methodsFor: 'Trait-CorteDeAnio' stamp: 'RamiroMachado 10/5/2013 01:58'!
cantidadDeAbandonadasDeAnio: unAnio

	^ self cantidadDeAbandonadas: (self obtenerCursadasDeAnio: unAnio) .! !

!EstadisticasPorAnio methodsFor: 'Requirements' stamp: 'RamiroMachado 10/5/2013 02:16'!
cantidadDeAprobadas: unAnio

	self requiredMethods.! !

!EstadisticasPorAnio methodsFor: 'Trait-CorteDeAnio' stamp: 'RamiroMachado 10/5/2013 01:59'!
cantidadDeAprobadasDeAnio: unAnio

	^ self cantidadDeAprobadas: (self obtenerCursadasDeAnio:unAnio).! !

!EstadisticasPorAnio methodsFor: 'Requirements' stamp: 'RamiroMachado 10/5/2013 02:16'!
cuantasNotasCon: unaNota deEstasCursadas: cursadas


	self requiredMethods.! !

!EstadisticasPorAnio methodsFor: 'Trait-CorteDeAnio' stamp: 'RamiroMachado 10/5/2013 01:59'!
cuantasNotasCon: unaNota enElAnio: unAnio


	^ self cuantasNotasCon: unaNota deEstasCursadas: (self obtenerCursadasDeAnio: unAnio) .! !

!EstadisticasPorAnio methodsFor: 'Requirements' stamp: 'RamiroMachado 10/5/2013 02:17'!
cuantasNotasMayorOIgual: unaNota deEstasCursadas: cursadas

	self requiredMethods.! !

!EstadisticasPorAnio methodsFor: 'Trait-CorteDeAnio' stamp: 'RamiroMachado 10/5/2013 02:01'!
cuantasNotasMayorOIgual: unaNota enElAnio: unAnio

	^ self cuantasNotasMayorOIgual: unaNota deEstasCursadas: (self obtenerCursadasDeAnio: unAnio).! !

!EstadisticasPorAnio methodsFor: 'Requirements' stamp: 'RamiroMachado 10/5/2013 02:17'!
notaMasAltaNVeces: nVeces deEstasCursadas: cursadas

	self requiredMethods.! !

!EstadisticasPorAnio methodsFor: 'Trait-CorteDeAnio' stamp: 'RamiroMachado 10/5/2013 02:01'!
notaMasAltaNVeces: nVeces enElAnio: unAnio

	^ self notaMasAltaNVeces: nVeces deEstasCursadas: (self obtenerCursadasDeAnio: unAnio). ! !

!EstadisticasPorAnio methodsFor: 'Requirements' stamp: 'JulianGalati 9/30/2013 02:35'!
obtenerCursadasDeAnio: unAnio

	self requiredMethods. 

! !

!EstadisticasPorAnio methodsFor: 'Requirements' stamp: 'RamiroMachado 10/5/2013 02:18'!
porcentajeDeAprobadosSobreIniciados: cursadas

	self requiredMethods.! !

!EstadisticasPorAnio methodsFor: 'Trait-CorteDeAnio' stamp: 'RamiroMachado 10/5/2013 02:02'!
porcentajeDeAprobadosSobreIniciadosDeAnio: unAnio

	^ self porcentajeDeAprobadosSobreIniciados: (self obtenerCursadasDeAnio: unAnio). ! !

!EstadisticasPorAnio methodsFor: 'Requirements' stamp: 'RamiroMachado 10/5/2013 02:18'!
promedioConAplazos: cursadas

	self requiredMethods.! !

!EstadisticasPorAnio methodsFor: 'Trait-CorteDeAnio' stamp: 'RamiroMachado 10/5/2013 02:02'!
promedioConAplazosDeAnio:unAnio

	^ self promedioConAplazos: (self obtenerCursadasDeAnio: unAnio).! !

!EstadisticasPorAnio methodsFor: 'Requirements' stamp: 'RamiroMachado 10/5/2013 02:19'!
promedioSinAplazos: cursadas

	self requiredMethods.! !

!EstadisticasPorAnio methodsFor: 'Trait-CorteDeAnio' stamp: 'RamiroMachado 10/5/2013 02:03'!
promedioSinAplazosDeAnio: unAnio

	^ self promedioSinAplazos: (self obtenerCursadasDeAnio: unAnio).! !

!EstadisticasPorAnio methodsFor: 'Requirements' stamp: 'RamiroMachado 10/5/2013 02:19'!
tablaNotas: cursadas

	self requiredMethods.! !

!EstadisticasPorAnio methodsFor: 'Trait-CorteDeAnio' stamp: 'RamiroMachado 10/5/2013 02:04'!
tablaNotasDeAnio: unAnio

	^ self tablaNotas: (self obtenerCursadasDeAnio: unAnio).! !

Trait named: #EstadisticasPorObjeto
	uses: {}
	category: 'Tp1'!

!EstadisticasPorObjeto methodsFor: 'Trait-Estadisticas' stamp: 'RamiroMachado 10/4/2013 19:21'!
cantidadDeAbandonadas

	^  self cantidadDeAbandonadas: (self obtenerCursadas).! !

!EstadisticasPorObjeto methodsFor: 'Requirements' stamp: 'RamiroMachado 10/5/2013 02:22'!
cantidadDeAbandonadas: unAnio

	self requiredMethods.! !

!EstadisticasPorObjeto methodsFor: 'Trait-Estadisticas' stamp: 'RamiroMachado 10/4/2013 19:21'!
cantidadDeAprobadas

	^ self cantidadDeAprobadas: (self obtenerCursadas).! !

!EstadisticasPorObjeto methodsFor: 'Requirements' stamp: 'RamiroMachado 10/5/2013 02:22'!
cantidadDeAprobadas: unAnio

	self requiredMethods.! !

!EstadisticasPorObjeto methodsFor: 'Requirements' stamp: 'RamiroMachado 10/5/2013 02:22'!
cuantasNotasCon: unaNota deEstasCursadas: cursadas


	self requiredMethods.! !

!EstadisticasPorObjeto methodsFor: 'Requirements' stamp: 'RamiroMachado 10/5/2013 02:23'!
cuantasNotasMayorOIgual: unaNota deEstasCursadas: cursadas

	self requiredMethods.! !

!EstadisticasPorObjeto methodsFor: 'Trait-Estadisticas' stamp: 'RamiroMachado 10/4/2013 19:23'!
notaMasAltaNVeces: nVeces 
	
	^ self notaMasAltaNVeces: nVeces deEstasCursadas:  (self obtenerCursadas). ! !

!EstadisticasPorObjeto methodsFor: 'Requirements' stamp: 'RamiroMachado 10/5/2013 02:23'!
notaMasAltaNVeces: nVeces deEstasCursadas: cursadas

	self requiredMethods.! !

!EstadisticasPorObjeto methodsFor: 'Requirements' stamp: 'RamiroMachado 10/5/2013 02:23'!
obtenerCursadas 
	self requiredMethods 
	
! !

!EstadisticasPorObjeto methodsFor: 'Trait-Estadisticas' stamp: 'RamiroMachado 10/4/2013 19:22'!
porcentajeDeAprobadosSobreIniciados

	^ self porcentajeDeAprobadosSobreIniciados: (self obtenerCursadas).! !

!EstadisticasPorObjeto methodsFor: 'Requirements' stamp: 'RamiroMachado 10/5/2013 02:24'!
porcentajeDeAprobadosSobreIniciados: cursadas

	self requiredMethods.! !

!EstadisticasPorObjeto methodsFor: 'Trait-Estadisticas' stamp: 'RamiroMachado 10/4/2013 19:21'!
promedioConAplazos

	^ self promedioConAplazos: (self obtenerCursadas).! !

!EstadisticasPorObjeto methodsFor: 'Requirements' stamp: 'RamiroMachado 10/5/2013 02:24'!
promedioConAplazos: cursadas

	self requiredMethods.! !

!EstadisticasPorObjeto methodsFor: 'Trait-Estadisticas' stamp: 'RamiroMachado 10/4/2013 19:21'!
promedioSinAplazos
	
	^ self promedioSinAplazos: (self obtenerCursadas).! !

!EstadisticasPorObjeto methodsFor: 'Requirements' stamp: 'RamiroMachado 10/5/2013 02:23'!
promedioSinAplazos: cursadas

	self requiredMethods.! !

!EstadisticasPorObjeto methodsFor: 'Requirements' stamp: 'RamiroMachado 10/5/2013 02:23'!
tablaNotas: cursadas

	self requiredMethods.! !

Trait named: #Utilidad
	uses: {}
	category: 'Tp1'!

!Utilidad methodsFor: 'TraitUtilidad' stamp: 'JulianGalati 9/13/2013 15:45'!
alcanzanEstosRecursos: unaListaDeRecursos




		^(self recursos) allSatisfy: [ :unRecurso | (unaListaDeRecursos occurrencesOf: unRecurso) >= ((self recursos) occurrencesOf: unRecurso)].
! !

!Utilidad methodsFor: 'Requirements' stamp: 'JulianGalati 9/13/2013 15:16'!
cantidadDeAsistentes

	self requiredMethods.! !

!Utilidad methodsFor: 'TraitUtilidad' stamp: 'JulianGalati 9/13/2013 15:21'!
meSirve: unAula

	 ^ (((self metrosCuadradosMinimosDePizarron) <= unAula superficieMetros2Pizarron) & ((self cantidadDeAsistentes) <= unAula capacidad) & (self alcanzanEstosRecursos:(unAula recursos) )).! !

!Utilidad methodsFor: 'Requirements' stamp: 'JulianGalati 9/13/2013 15:15'!
metrosCuadradosMinimosDePizarron

	self requiredMethods.! !

!Utilidad methodsFor: 'Requirements' stamp: 'JulianGalati 9/13/2013 15:04'!
recursos

	self requiredMethods.! !

TestCase subclass: #AlumnoTest
	instanceVariableNames: 'unAulumnoConTresCursos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-Tests'!

!AlumnoTest commentStamp: '<historical>' prior: 0!
An AlumnoTest is a test class for testing the behavior of Alumno!

!AlumnoTest methodsFor: 'SetUp' stamp: 'JulianGalati 9/30/2013 03:50'!
setUp

	"Este setUp crea un alumno con 3 cursos, los cuales tienen las notas (ausente), 2, 8"
	|unCurso listaDeDocentes listaDeAlumnos|
	
	listaDeAlumnos:= Bag new.
	listaDeDocentes:= Bag new.
	
	listaDeDocentes add: (Docente new:'Franco Bulgarelli').

	unAulumnoConTresCursos := Alumno new:'Ramiro Machado' legajo:1415700.
	listaDeAlumnos add: (unAulumnoConTresCursos). 	
	
	unCurso:= Curso new:  2012 docentes:  listaDeDocentes alumnos: listaDeAlumnos.
	
	unCurso:= Curso new:  2013 docentes:  listaDeDocentes alumnos: listaDeAlumnos.
	
	unCurso agregaEstaNota: 2 aEsteAlumno: unAulumnoConTresCursos.
	
	unCurso:= Curso new:  2013 docentes:  listaDeDocentes alumnos: listaDeAlumnos.
	
	unCurso agregaEstaNota: 8  aEsteAlumno: unAulumnoConTresCursos.
	
	
	
	
	! !

!AlumnoTest methodsFor: 'Estadisticas' stamp: 'JulianGalati 9/30/2013 04:28'!
testObtenerCursadas

	| cursadas |
	cursadas := unAulumnoConTresCursos obtenerCursadas.
	self assert: (cursadas size) = 3.! !

!AlumnoTest methodsFor: 'CorteDeAnio' stamp: 'JulianGalati 9/30/2013 04:29'!
testObtenerCursadasDeAnio2012

	| cursadas |
	cursadas  := unAulumnoConTresCursos  obtenerCursadasDeAnio: 2012.
	self assert: (cursadas  size) = 1.! !

!AlumnoTest methodsFor: 'CorteDeAnio' stamp: 'JulianGalati 9/30/2013 04:30'!
testObtenerCursadasDeAnio2013

	| cursadas |
	cursadas := unAulumnoConTresCursos  obtenerCursadasDeAnio:2013.
	self assert: (cursadas size) = 2.! !

!AlumnoTest methodsFor: 'Estadisticas' stamp: 'RamiroMachado 10/4/2013 19:20'!
testPromedioSinAplazos

	self assert: (unAulumnoConTresCursos  promedioSinAplazos ) = 8.! !

TestCase subclass: #CarreraTest
	instanceVariableNames: 'unaCarreraCon2Materias'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-Tests'!

!CarreraTest commentStamp: '<historical>' prior: 0!
A CarreraTest is a test class for testing the behavior of Carrera!

!CarreraTest methodsFor: 'SetUp' stamp: 'JulianGalati 9/30/2013 04:56'!
setUp

	"Este setUp crea una carrera con 1 materia, con 3 cursos, los cuales tienen las notas (ausente), 2, 8"
	|unCurso listaDeDocentes listaDeAlumnos unaMateriaCon2Cursos ramiroAlumno |
	
	unaCarreraCon2Materias := Carrera new: 'Ingenieria en Sistemas'.
	unaMateriaCon2Cursos := Materia new:'TADP'.
	listaDeAlumnos:= Bag new.
	listaDeDocentes:= Bag new.
	
	listaDeDocentes add: (Docente new:'Franco Bulgarelli').
	ramiroAlumno:= (Alumno new:'Ramiro Machado' legajo:1415700).
	listaDeAlumnos add: ramiroAlumno. 	
	
	unCurso:= Curso new:  2013 docentes:  listaDeDocentes alumnos: listaDeAlumnos.
	
	
	unaMateriaCon2Cursos agregarUnCurso: unCurso.
	
	unCurso:= Curso new:  2013 docentes:  listaDeDocentes alumnos: listaDeAlumnos.
	unCurso agregaEstaNota: 2 aEsteAlumno: ramiroAlumno.
	unaMateriaCon2Cursos agregarUnCurso: unCurso.
	
	unCurso:= Curso new:  2013 docentes:  listaDeDocentes alumnos: listaDeAlumnos.
	unCurso agregaEstaNota: 8 aEsteAlumno: ramiroAlumno.
	unaMateriaCon2Cursos agregarUnCurso: unCurso.
	
	unaCarreraCon2Materias agregarUnaMateria: unaMateriaCon2Cursos.	! !

!CarreraTest methodsFor: 'Estadisticas' stamp: 'JulianGalati 9/30/2013 04:30'!
testObtenerCursadas

	| cursadas |
	cursadas := unaCarreraCon2Materias obtenerCursadas.
	self assert: (cursadas size) = 3.! !

TestCase subclass: #CursoTest
	instanceVariableNames: 'unCursoConTresAlumnos aulaQueSirve aulaQueNoSirve'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-Tests'!

!CursoTest methodsFor: 'SetUp' stamp: 'JulianGalati 9/30/2013 04:56'!
setUp

	"Este setUp crea un curso con 3 alumnos y 1 docente, los cuales tienen las notas (ausente), 2, 10"
	|unCurso listaDeDocentes listaDeAlumnos alumnoRamiro alumnoJulian alumnoDiego |
	
	listaDeAlumnos:= Bag new.
	listaDeDocentes:= Bag new.
	
	listaDeDocentes add: (Docente new:'Franco Bulgarelli').

	alumnoRamiro := (Alumno new:'Ramiro Machado' legajo:1415700). 
	alumnoJulian := (Alumno new:'Julian Galati' legajo:1405317).
	alumnoDiego := (Alumno new:'Diego Salomon' legajo:1378259).
	listaDeAlumnos add: alumnoRamiro.	
	listaDeAlumnos add: alumnoJulian.
	listaDeAlumnos add: alumnoDiego.
	
	unCursoConTresAlumnos  := Curso new:  2013 docentes:  listaDeDocentes alumnos: listaDeAlumnos.
	
	
	unCursoConTresAlumnos agregaEstaNota: 2 aEsteAlumno:  alumnoJulian.
	unCursoConTresAlumnos agregaEstaNota: 10 aEsteAlumno: alumnoDiego.
	
	unCursoConTresAlumnos  recursos: Bag new.
	unCursoConTresAlumnos recursos add: 'microfono'.
	unCursoConTresAlumnos recursos add: 'proyector'.
	unCursoConTresAlumnos metrosCuadradosMinimosDePizarron: 50. 
	unCursoConTresAlumnos diaDeSemana: 'Lunes'.
	unCursoConTresAlumnos horaInicio: '20:30'.
	unCursoConTresAlumnos horaFin: '21:30'.
	unCursoConTresAlumnos fechaInicio: ' 15/03'.
	unCursoConTresAlumnos fechaFin:'15/09'.

	 	
	aulaQueSirve := Aula new:  ({'microfono'}, {'proyector'}, {'ventilador'})
			superficie: 60 capacidad: 1000.
	
	aulaQueNoSirve := Aula new:({'microfono'}, {'ventilador'}) 
			superficie: 30 capacidad: 10.
	
	
	
	! !

!CursoTest methodsFor: 'Estadisticas' stamp: 'JulianGalati 9/13/2013 13:35'!
testCantidadCursadasAbadonadas
	
	self assert: (unCursoConTresAlumnos cantidadDeAbandonadas)  = 1.! !

!CursoTest methodsFor: 'Estadisticas' stamp: 'JulianGalati 9/13/2013 13:38'!
testCantidadCursadasAprobadas


	self assert: unCursoConTresAlumnos cantidadDeAprobadas  = 1.! !

!CursoTest methodsFor: 'Estadisticas' stamp: 'JulianGalati 9/13/2013 13:40'!
testCualEsLaNotaMasAltaQueSeAlcanzoDosVeces

	self assert: (unCursoConTresAlumnos notaMasAltaNVeces: 2)  = 2.! !

!CursoTest methodsFor: 'Estadisticas' stamp: 'JulianGalati 9/13/2013 13:49'!
testCualEsLaNotaMasAltaQueSeAlcanzoTresVeces

	self assert: (unCursoConTresAlumnos notaMasAltaNVeces: 3)  equals: 'No habia notas suficientes'.! !

!CursoTest methodsFor: 'Estadisticas' stamp: 'JulianGalati 9/13/2013 13:39'!
testCualEsLaNotaMasAltaQueSeAlcanzoUnaVez

	self assert: (unCursoConTresAlumnos notaMasAltaNVeces: 1)  = 10.! !

!CursoTest methodsFor: 'MeSirve' stamp: 'macha 9/14/2013 01:27'!
testMeSirveUnAula
	
	
	self assert: (unCursoConTresAlumnos meSirve: aulaQueSirve).
	self assert: ((unCursoConTresAlumnos meSirve: aulaQueNoSirve) not).! !

!CursoTest methodsFor: 'Estadisticas' stamp: 'JulianGalati 9/13/2013 13:44'!
testPorcentajeAprobadosSobreIniciados

	self assert: (unCursoConTresAlumnos porcentajeDeAprobadosSobreIniciados ) = ((1/ 3)*100).! !

!CursoTest methodsFor: 'Estadisticas' stamp: 'JulianGalati 9/13/2013 13:45'!
testPromedioConAplazos

	
	self assert: (unCursoConTresAlumnos promedioConAplazos ) = 6.! !

!CursoTest methodsFor: 'Estadisticas' stamp: 'RamiroMachado 10/4/2013 19:24'!
testPromedioSinAplazos
	
	
	self assert: (unCursoConTresAlumnos promedioSinAplazos) = 10.! !

TestCase subclass: #DocenteTest
	instanceVariableNames: 'unDocenteCon3Cursos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-Tests'!

!DocenteTest commentStamp: '<historical>' prior: 0!
A DocenteTest is a test class for testing the behavior of Docente!

!DocenteTest methodsFor: 'SetUp' stamp: 'JulianGalati 9/30/2013 04:56'!
setUp

	"Este setUp crea un docente con 3 cursos, los cuales tienen las notas (ausente),(ausente) 2,3, 8"
	|unCurso listaDeDocentes listaDeAlumnos unAulumno alumnoJulian alumnoDiego |
	
	listaDeAlumnos:= Bag new.
	listaDeDocentes:= Bag new.
	
	unDocenteCon3Cursos :=  (Docente new:'Franco Bulgarelli').
	listaDeDocentes add: unDocenteCon3Cursos .

	unAulumno := Alumno new:'Ramiro Machado' legajo:1415700.
	listaDeAlumnos add: (unAulumno). 
	
	unCurso:= Curso new:  2013 docentes:  listaDeDocentes alumnos: listaDeAlumnos.
	

	
	unCurso:= Curso new:  2013 docentes:  listaDeDocentes alumnos: listaDeAlumnos.
	
	unCurso agregaEstaNota: 2 aEsteAlumno: unAulumno.
	
	alumnoJulian := (Alumno new:'Julian Galati' legajo:1405317).
	alumnoDiego := (Alumno new:'Diego Salomon' legajo:1378259).
	listaDeAlumnos add: alumnoJulian. 	
	listaDeAlumnos add: alumnoDiego.
	unCurso:= Curso new:  2013 docentes:  listaDeDocentes alumnos: listaDeAlumnos.
	
	unCurso agregaEstaNota: 8 aEsteAlumno: unAulumno.
	
	unCurso agregaEstaNota: 3 aEsteAlumno: alumnoDiego.
	
	
	
	
	! !

!DocenteTest methodsFor: 'Estadisticas' stamp: 'JulianGalati 9/30/2013 04:31'!
testObtenerCursadas

	| cursadas |
	cursadas := unDocenteCon3Cursos obtenerCursadas.
	self assert: (cursadas size) = 5.! !

TestCase subclass: #GrupoDeInvestigacionTest
	instanceVariableNames: 'unGrupoCon2ActividadesAprobadas1EnEspera unGrupoCon2ActividadesAprobadosCon1Proyecto2Articulos unAlumnoConAgenda'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-Tests'!

!GrupoDeInvestigacionTest commentStamp: '<historical>' prior: 0!
A GrupoDeInvestigacionTest is a test class for testing the behavior of GrupoDeInvestigacion!

!GrupoDeInvestigacionTest methodsFor: 'SetUp' stamp: 'RamiroMachado 9/29/2013 22:25'!
setUp

	 | unaActividad unProyecto unResultado listaDeAlumnos |


	unAlumnoConAgenda  := Alumno new:'Diegote' legajo:1415700.
	unGrupoCon2ActividadesAprobadas1EnEspera  := GrupoDeInvestigacion new:{ unAlumnoConAgenda }.
	
	unGrupoCon2ActividadesAprobadosCon1Proyecto2Articulos := GrupoDeInvestigacion new:{}.
	
	listaDeAlumnos := Bag new.
	listaDeAlumnos add: unAlumnoConAgenda.

	unaActividad := Charla new:'Actividad 1' monto:10000 fechaPresentada: '10-08-2013' responsables: {} integrantes: listaDeAlumnos.
	unaActividad fecha: '19/05/2001'.
	unaActividad horaDesde: '09:30'.
	unaActividad horaHasta: '10:30'.
	unGrupoCon2ActividadesAprobadas1EnEspera agregarActividad: unaActividad.
	

	unaActividad := Charla new:'Actividad 2' monto:5000 fechaPresentada: '10-08-2013' responsables: {} integrantes:{}.
	unaActividad fecha: '19/05/2006'.
	unaActividad  horaDesde: '11:30'.
	unaActividad  horaHasta: '12:30'.
	unaActividad fechaAprobada: '10-10-2013'.
	unGrupoCon2ActividadesAprobadas1EnEspera agregarActividad: unaActividad.
	
	unaActividad := Charla new:'Actividad 3' monto:15000 fechaPresentada: '10-09-2013' responsables: {} integrantes: listaDeAlumnos.
	unaActividad fechaAprobada: '10-10-2013'.
	unaActividad fecha: '19/05/2013'.
	unaActividad  horaDesde: '19:30'.
	unaActividad  horaHasta: '22:30'.
	unGrupoCon2ActividadesAprobadas1EnEspera agregarActividad: unaActividad.
	
	unGrupoCon2ActividadesAprobadosCon1Proyecto2Articulos agregarActividad: unaActividad.
	
	unProyecto := Proyecto new:'Actividad 4' monto:15000 fechaPresentada: '10-09-2013' responsables: {} integrantes:{} resultados: {}.
	unProyecto fechaAprobada: '10-10-2013'.
	
	unResultado := OrderedCollection new.
	unResultado add: 'articulo sobre fotones'.
	unResultado add: '12-10-2010'.
	unProyecto agregarResultado: unResultado.
	
	unResultado := OrderedCollection new.
	unResultado add: 'articulo sobre fisicacuantica'.
	unResultado add: '12-10-2012'.
	unProyecto agregarResultado: unResultado.
	
	unResultado := OrderedCollection new.
	unResultado add: 'esto no es un art ic ulo'.
	unResultado add: '12-11-2012'.
	unProyecto agregarResultado: unResultado.

	
	
	unGrupoCon2ActividadesAprobadosCon1Proyecto2Articulos agregarActividad: unProyecto.
	
	! !

!GrupoDeInvestigacionTest methodsFor: 'Domain' stamp: 'JulianGalati 9/13/2013 17:09'!
testActividadesAunNoAprobadas

	self assert: ((unGrupoCon2ActividadesAprobadas1EnEspera actividadesAunNoAprobadas) size = 1).! !

!GrupoDeInvestigacionTest methodsFor: 'Domain' stamp: 'macha 9/13/2013 22:53'!
testArticulosPublicados

	self assert: (((unGrupoCon2ActividadesAprobadosCon1Proyecto2Articulos articulosYSusFechasDeLosProyectos) size) = 2).! !

!GrupoDeInvestigacionTest methodsFor: 'Domain' stamp: 'macha 9/13/2013 23:50'!
testObtenerAgenda

	self assert: ((unAlumnoConAgenda agendaDeEventos ) size = 2).
	self assert: ((((unAlumnoConAgenda agendaDeEventos )first) first ) = '19/05/2001').! !

!GrupoDeInvestigacionTest methodsFor: 'Domain' stamp: 'JulianGalati 9/13/2013 17:13'!
testmontoTotalDeActividadesAunNoAprobadas

	self assert: ((unGrupoCon2ActividadesAprobadas1EnEspera montoTotalDeActividadesAunNoAprobadas) = 10000).! !

TestCase subclass: #MateriaTest
	instanceVariableNames: 'unaMateriaCon2Cursos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1-Tests'!

!MateriaTest commentStamp: '<historical>' prior: 0!
A MateriaTest is a test class for testing the behavior of Materia!

!MateriaTest methodsFor: 'SetUp' stamp: 'JulianGalati 9/30/2013 04:57'!
setUp

	"Este setUp crea un alumno con 3 cursos, los cuales tienen las notas (ausente), 2, 8"
	|unCurso listaDeDocentes listaDeAlumnos ramiroAlumno |
	
	unaMateriaCon2Cursos := Materia new:'TADP'.
	listaDeAlumnos:= Bag new.
	listaDeDocentes:= Bag new.
	
	listaDeDocentes add: (Docente new:'Franco Bulgarelli').
	ramiroAlumno := (Alumno new:'Ramiro Machado' legajo:1415700). 	
	listaDeAlumnos add: ramiroAlumno. 
	
	unCurso:= Curso new:  2013 docentes:  listaDeDocentes alumnos: listaDeAlumnos.

	
	unaMateriaCon2Cursos agregarUnCurso: unCurso.
	
	unCurso:= Curso new:  2013 docentes:  listaDeDocentes alumnos: listaDeAlumnos.
	unCurso agregaEstaNota: 2 aEsteAlumno: ramiroAlumno.
	unaMateriaCon2Cursos agregarUnCurso: unCurso.
	
	unCurso:= Curso new:  2013 docentes:  listaDeDocentes alumnos: listaDeAlumnos.
	unCurso agregaEstaNota: 8 aEsteAlumno: ramiroAlumno.
	unaMateriaCon2Cursos agregarUnCurso: unCurso.
	
	
	
	
	! !

!MateriaTest methodsFor: 'Estadisticas' stamp: 'JulianGalati 9/30/2013 04:31'!
testObtenerCursadas

	| cursadas |
	cursadas := unaMateriaCon2Cursos  obtenerCursadas.
	self assert: (cursadas size) = 3.! !

Object subclass: #Actividad
	instanceVariableNames: 'nombre monto fechaPresentada FechaAprobada responsable integrantes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1'!

!Actividad class methodsFor: 'Constructor' stamp: 'macha 9/13/2013 22:16'!
new: nombre monto: montoFinanciamiento fechaPresentada: unaFecha responsables: listaDeResponsables integrantes: listaDeIntegrantes

	| unaActividad |
	
	unaActividad := Actividad new.
	unaActividad nombre: nombre.
	unaActividad monto: montoFinanciamiento.
	unaActividad fechaPresentada: unaFecha.
	unaActividad responsable: listaDeResponsables.
	unaActividad integrantes: listaDeIntegrantes.
	
	^unaActividad.! !

!Actividad methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 14:23'!
aprobada
	^ (self fechaAprobada = nil) not.! !

!Actividad methodsFor: 'Domain' stamp: 'JulianGalati 9/13/2013 14:05'!
decimeTusArticulos

	^ Bag new.! !

!Actividad methodsFor: 'Domain' stamp: 'macha 9/13/2013 23:13'!
decimeTusEventos

 self requiredMethods.! !

!Actividad methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 14:16'!
fechaAprobada
	^ FechaAprobada! !

!Actividad methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 14:16'!
fechaAprobada: anObject
	FechaAprobada := anObject! !

!Actividad methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 14:16'!
fechaPresentada
	^ fechaPresentada! !

!Actividad methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 14:16'!
fechaPresentada: anObject
	fechaPresentada := anObject! !

!Actividad methodsFor: 'Domain' stamp: 'macha 9/13/2013 23:35'!
integranteEsta: unIntegrante

	^ (integrantes anySatisfy: [ :x |  (unIntegrante legajo) = (x legajo)]).! !

!Actividad methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 14:16'!
integrantes
	^ integrantes! !

!Actividad methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 14:16'!
integrantes: anObject
	integrantes := anObject! !

!Actividad methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 12:37'!
monto
	^ monto! !

!Actividad methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 12:37'!
monto: anObject
	monto := anObject! !

!Actividad methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 14:16'!
nombre
	^ nombre! !

!Actividad methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 14:16'!
nombre: anObject
	nombre := anObject! !

!Actividad methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 14:16'!
responsable
	^ responsable! !

!Actividad methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 14:16'!
responsable: anObject
	responsable := anObject! !

Actividad subclass: #Charla
	uses: Utilidad
	instanceVariableNames: 'fecha horaDesde horaHasta publico metrosCuadradosMinimosDePizarron recursos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1'!

Charla class
	uses: Utilidad classTrait
	instanceVariableNames: ''!

!Charla class methodsFor: 'Constructor' stamp: 'macha 9/13/2013 22:38'!
new: nombre monto: montoFinanciamiento fechaPresentada: unaFecha responsables: listaDeResponsables integrantes: listaDeIntegrantes

	| unaActividad |
	
	unaActividad := Charla new.
	unaActividad nombre: nombre.
	unaActividad monto: montoFinanciamiento.
	unaActividad fechaPresentada: unaFecha.
	unaActividad responsable: listaDeResponsables.
	unaActividad integrantes: listaDeIntegrantes.
	
	^unaActividad.! !

!Charla methodsFor: 'Domain' stamp: 'JulianGalati 9/13/2013 16:01'!
cantidadDeAsistentes

	^(self integrantes size) + (self publico size) + (self responsable size)
	! !

!Charla methodsFor: 'Domain' stamp: 'macha 9/13/2013 23:58'!
decimeTusEventos

	^ {self fecha} , {self horaDesde} , {self horaHasta} , {self nombre}.! !

!Charla methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 15:56'!
fecha
	^ fecha! !

!Charla methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 15:56'!
fecha: anObject
	fecha := anObject! !

!Charla methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 15:56'!
horaDesde
	^ horaDesde! !

!Charla methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 15:56'!
horaDesde: anObject
	horaDesde := anObject! !

!Charla methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 15:56'!
horaHasta
	^ horaHasta! !

!Charla methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 15:56'!
horaHasta: anObject
	horaHasta := anObject! !

!Charla methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 15:56'!
metrosCuadradosMinimosDePizarron
	^ metrosCuadradosMinimosDePizarron! !

!Charla methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 15:56'!
metrosCuadradosMinimosDePizarron: anObject
	metrosCuadradosMinimosDePizarron := anObject! !

!Charla methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 15:56'!
publico
	^ publico! !

!Charla methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 15:56'!
publico: anObject
	publico := anObject! !

!Charla methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 15:56'!
recursos
	^ recursos! !

!Charla methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 15:56'!
recursos: anObject
	recursos := anObject! !

Actividad subclass: #Proyecto
	instanceVariableNames: 'resultados experimentos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1'!

!Proyecto class methodsFor: 'Constructor' stamp: 'RamiroMachado 9/29/2013 22:38'!
new: nombre monto: montoFinanciamiento fechaPresentada: unaFecha responsables: listaDeResponsables integrantes: listaDeIntegrantes resultados: listaDeResultados

	| unaActividad |
	
	unaActividad := Proyecto new.
	unaActividad nombre: nombre.
	unaActividad monto: montoFinanciamiento.
	unaActividad fechaPresentada: unaFecha.
	unaActividad responsable: Bag new.
	unaActividad integrantes: Bag new.
	unaActividad resultados: Bag new.
	
	listaDeResponsables do: [ :unResponsable | self responsable add unResponsable].
	listaDeIntegrantes do: [ :unIntegrante | self integrantes add: unIntegrante].
	listaDeResultados do: [ :unResultado | self resultados add: unResultado].
	
	^unaActividad.! !

!Proyecto methodsFor: 'Accessing' stamp: 'RamiroMachado 9/29/2013 22:27'!
agregarResultado: unResultado

	self resultados add: unResultado.! !

!Proyecto methodsFor: 'Domain' stamp: 'JulianGalati 9/13/2013 14:11'!
decimeTusArticulos 

  ^ (resultados select: [ :unResultado | (unResultado first) includesSubString: 'articulo' ]).! !

!Proyecto methodsFor: 'Domain' stamp: 'macha 9/13/2013 23:14'!
decimeTusEventos 

	^ self experimentos.! !

!Proyecto methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 14:45'!
experimentos
	^ experimentos! !

!Proyecto methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 14:45'!
experimentos: anObject
	experimentos := anObject! !

!Proyecto methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 14:45'!
resultados
	^ resultados! !

!Proyecto methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 14:45'!
resultados: anObject
	resultados := anObject! !

Actividad subclass: #Seminario
	uses: Utilidad
	instanceVariableNames: 'sesiones metrosCuadradosMinimosDePizarron recursos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1'!

Seminario class
	uses: Utilidad classTrait
	instanceVariableNames: ''!

!Seminario class methodsFor: 'Constructor' stamp: 'macha 9/13/2013 22:38'!
new: nombre monto: montoFinanciamiento fechaPresentada: unaFecha responsables: listaDeResponsables integrantes: listaDeIntegrantes

	| unaActividad |
	
	unaActividad := Seminario new.
	unaActividad nombre: nombre.
	unaActividad monto: montoFinanciamiento.
	unaActividad fechaPresentada: unaFecha.
	unaActividad responsable: listaDeResponsables.
	unaActividad integrantes: listaDeIntegrantes.
	
	^unaActividad.! !

!Seminario methodsFor: 'Domain' stamp: 'JulianGalati 9/13/2013 16:04'!
cantidadDeAsistentes

	^(self responsable size) + (self integrantes size)! !

!Seminario methodsFor: 'Domain' stamp: 'JulianGalati 9/13/2013 14:40'!
decimeTusEventos 

	^ (sesiones inject: Bag new into:[ :acum :unaSesion |  acum , (unaSesion, {self nombre} ) ]).! !

!Seminario methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 16:03'!
metrosCuadradosMinimosDePizarron
	^ metrosCuadradosMinimosDePizarron! !

!Seminario methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 16:03'!
metrosCuadradosMinimosDePizarron: anObject
	metrosCuadradosMinimosDePizarron := anObject! !

!Seminario methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 16:03'!
recursos
	^ recursos! !

!Seminario methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 16:03'!
recursos: anObject
	recursos := anObject! !

!Seminario methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 16:03'!
sesiones
	^ sesiones! !

!Seminario methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 16:03'!
sesiones: anObject
	sesiones := anObject! !

Object subclass: #Alumno
	uses: EstadisticasPorObjeto - {#Requirements} + EstadisticasPorAnio - {#filtrarAbandono:. #filtrarAprobados:. #filtrarPresentes:} + Agenda
	instanceVariableNames: 'legajo nombre cursos grupos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1'!

Alumno class
	uses: EstadisticasPorObjeto classTrait + EstadisticasPorAnio classTrait + Agenda classTrait
	instanceVariableNames: ''!

!Alumno class methodsFor: 'Constructor' stamp: 'macha 9/13/2013 23:25'!
new:  nombreA legajo:legajoA
	
	|unAlumno|
	
	unAlumno :=Alumno new.
	
	unAlumno  legajo: legajoA.
	unAlumno  nombre: nombreA.
	unAlumno  cursos: Bag new.
	unAlumno  grupos: Bag new.
	
	^ unAlumno .! !

!Alumno methodsFor: 'Accessing' stamp: 'RamiroMachado 9/29/2013 21:34'!
agregarUnCurso: unCurso

	(self cursos) add: unCurso.! !

!Alumno methodsFor: 'Accessing' stamp: 'Anonymous 9/7/2013 15:34'!
cursos
	^ cursos! !

!Alumno methodsFor: 'Accessing' stamp: 'Anonymous 9/7/2013 15:34'!
cursos: anObject
	cursos := anObject! !

!Alumno methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 12:24'!
grupos
	^ grupos! !

!Alumno methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 12:24'!
grupos: anObject
	grupos := anObject! !

!Alumno methodsFor: 'Accessing' stamp: 'Anonymous 9/7/2013 15:34'!
legajo
	^ legajo! !

!Alumno methodsFor: 'Accessing' stamp: 'Anonymous 9/7/2013 15:34'!
legajo: anObject
	legajo := anObject! !

!Alumno methodsFor: 'Accessing' stamp: 'Anonymous 9/7/2013 15:34'!
nombre
	^ nombre! !

!Alumno methodsFor: 'Accessing' stamp: 'Anonymous 9/7/2013 15:34'!
nombre: anObject
	nombre := anObject! !

!Alumno methodsFor: 'Domain' stamp: 'JulianGalati 9/30/2013 02:59'!
obtenerCursadas 
	"comment stating purpose of message"
	
	|listaDeCursadas|
	
	listaDeCursadas  := Bag new.
	self cursos do:[:unCurso | listaDeCursadas add: (unCurso dameMiCursada: self)  ].
	^ listaDeCursadas.
	! !

!Alumno methodsFor: 'Domain' stamp: 'JulianGalati 9/30/2013 03:07'!
obtenerCursadasDeAnio: unAnio
	
	
	|listaDeCursadas|
	
	listaDeCursadas := Bag new.
	self cursos do:[:unCurso |   (unAnio =  (unCurso anio)) ifTrue:[listaDeCursadas add: (unCurso dameMiCursada: self) ]  ].
	^ listaDeCursadas.
	
	! !

Object subclass: #Aula
	instanceVariableNames: 'superficieMetros2Pizarron recursos capacidad'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1'!

!Aula class methodsFor: 'as yet unclassified' stamp: 'RamiroMachado 9/29/2013 21:57'!
new: Recursos superficie: superficie capacidad: laCapacidad

	| unAula |
	
	unAula := Aula new.
	
	unAula recursos: Recursos.
	unAula superficieMetros2Pizarron: superficie.
	unAula capacidad: laCapacidad .
	
	^unAula.

	
! !

!Aula methodsFor: 'Accesing' stamp: 'RamiroMachado 9/29/2013 21:43'!
agregarRecurso: unRecurso

	(self recursos) add: unRecurso.! !

!Aula methodsFor: 'Accesing' stamp: 'JulianGalati 9/13/2013 15:10'!
capacidad
	^ capacidad! !

!Aula methodsFor: 'Accesing' stamp: 'JulianGalati 9/13/2013 15:10'!
capacidad: anObject
	capacidad := anObject! !

!Aula methodsFor: 'Accesing' stamp: 'JulianGalati 9/13/2013 15:10'!
recursos
	^ recursos! !

!Aula methodsFor: 'Accesing' stamp: 'JulianGalati 9/13/2013 15:10'!
recursos: anObject
	recursos := anObject! !

!Aula methodsFor: 'Accesing' stamp: 'JulianGalati 9/13/2013 15:10'!
superficieMetros2Pizarron
	^ superficieMetros2Pizarron! !

!Aula methodsFor: 'Accesing' stamp: 'JulianGalati 9/13/2013 15:10'!
superficieMetros2Pizarron: anObject
	superficieMetros2Pizarron := anObject! !

Object subclass: #Carrera
	uses: EstadisticasPorObjeto
	instanceVariableNames: 'nombre materias'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1'!

Carrera class
	uses: EstadisticasPorObjeto classTrait
	instanceVariableNames: ''!

!Carrera class methodsFor: 'Constructor' stamp: 'macha 9/11/2013 10:06'!
new: nombreCarreraParam

	|unaCarrera|

	unaCarrera :=Carrera new.
	unaCarrera  nombre: nombreCarreraParam.
	unaCarrera  materias: Bag new.
	^unaCarrera.! !

!Carrera methodsFor: 'Accessing' stamp: 'RamiroMachado 9/29/2013 21:31'!
agregarUnaMateria: unaMateria

	(self materias) add: unaMateria.! !

!Carrera methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:46'!
materias
	^ materias! !

!Carrera methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:46'!
materias: anObject
	materias := anObject! !

!Carrera methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:46'!
nombre
	^ nombre! !

!Carrera methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:46'!
nombre: anObject
	nombre := anObject! !

!Carrera methodsFor: 'Domain' stamp: 'JulianGalati 9/30/2013 03:11'!
obtenerCursadas 

	|listaDeCursadas|
	
	listaDeCursadas := Bag new.
	
	materias do: [ :unaMateria | listaDeCursadas := (unaMateria  obtenerCursadas, listaDeCursadas)].
	
	^ listaDeCursadas.! !

Object subclass: #Cursada
	instanceVariableNames: 'Alumno Nota'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1'!

!Cursada class methodsFor: 'Constructors' stamp: 'JulianGalati 9/30/2013 02:15'!
new: unAlumno

|unaCursada|

unaCursada := Cursada new.

unaCursada alumno: unAlumno.

unaCursada nota: nil.   

^unaCursada.! !

!Cursada methodsFor: 'accessing' stamp: 'JulianGalati 9/30/2013 02:14'!
alumno
	^ Alumno! !

!Cursada methodsFor: 'accessing' stamp: 'JulianGalati 9/30/2013 02:14'!
alumno: anObject
	Alumno := anObject! !

!Cursada methodsFor: 'Domain' stamp: 'JulianGalati 9/30/2013 04:00'!
estasAprobada

	(self terminasteLaCursada) ifTrue:[^((self nota) > 3)] ifFalse:[self error: 'La cursada no se finaliz y se quizo saber si estaba aprobada'].
	! !

!Cursada methodsFor: 'accessing' stamp: 'JulianGalati 9/30/2013 02:14'!
nota
	^ Nota! !

!Cursada methodsFor: 'accessing' stamp: 'JulianGalati 9/30/2013 02:14'!
nota: anObject
	Nota := anObject! !

!Cursada methodsFor: 'Domain' stamp: 'JulianGalati 9/30/2013 03:04'!
sosLaCursadaDe: unAlumno 

	^(unAlumno == (self alumno)).! !

!Cursada methodsFor: 'Domain' stamp: 'JulianGalati 9/30/2013 02:18'!
terminasteLaCursada

	^(self nota ~= nil).! !

Object subclass: #Curso
	uses: EstadisticasPorObjeto + Utilidad
	instanceVariableNames: 'docentes cursadas anio cuatrimestre alumnos recursos metrosCuadradosMinimosDePizarron diaDeSemana horaInicio horaFin fechaInicio fechaFin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1'!

Curso class
	uses: EstadisticasPorObjeto classTrait + Utilidad classTrait
	instanceVariableNames: ''!

!Curso class methodsFor: 'Constructor' stamp: 'JulianGalati 9/30/2013 03:51'!
new: unAnio docentes: listaDeDocentes alumnos: listaDeAlumnos

	|unCurso|
	unCurso:=Curso new.
	unCurso anio: unAnio.
	unCurso docentes: listaDeDocentes.
	unCurso alumnos: listaDeAlumnos.
	unCurso cursadas: Bag new.
	
	listaDeDocentes do: [ :unDocente | unDocente agregarUnCurso: unCurso].	
	listaDeAlumnos do: [ :unAlumno | unAlumno agregarUnCurso: unCurso. unCurso cursadas add: (Cursada new: unAlumno )].
	
	^ unCurso.! !

!Curso methodsFor: 'Accessing' stamp: 'JulianGalati 9/30/2013 03:48'!
agregaEstaNota: unaNota aEsteAlumno: unAlumno

	(self dameMiCursada: unAlumno) nota: unaNota.

! !

!Curso methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 12:41'!
agregarAlumno: unAlumno

	alumnos add: unAlumno.
	unAlumno cursos add: self.




	! !

!Curso methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 12:41'!
agregarDocente: unDocente

	docentes add: unDocente .
	unDocente cursos add: self.



	! !

!Curso methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:47'!
alumnos
	^ alumnos! !

!Curso methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:47'!
alumnos: anObject
	alumnos := anObject! !

!Curso methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:47'!
anio
	^ anio! !

!Curso methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:47'!
anio: anObject
	anio := anObject! !

!Curso methodsFor: 'Domain' stamp: 'JulianGalati 9/13/2013 15:51'!
cantidadDeAsistentes

	^self alumnos size + (self docentes size).! !

!Curso methodsFor: 'Accessing' stamp: 'RamiroMachado 10/4/2013 18:46'!
cuatrimestre
	^ cuatrimestre! !

!Curso methodsFor: 'Accessing' stamp: 'RamiroMachado 10/4/2013 18:46'!
cuatrimestre: anObject
	cuatrimestre := anObject! !

!Curso methodsFor: 'Accessing' stamp: 'JulianGalati 9/30/2013 03:01'!
cursadas
	^ cursadas! !

!Curso methodsFor: 'Accessing' stamp: 'JulianGalati 9/30/2013 03:01'!
cursadas: anObject
	cursadas := anObject! !

!Curso methodsFor: 'Domain' stamp: 'JulianGalati 9/30/2013 03:56'!
dameMiCursada: unAlumno

	(self cursadas do: [:unaCursada | (unaCursada sosLaCursadaDe: unAlumno) ifTrue: [ ^unaCursada ] ]).! !

!Curso methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 15:53'!
diaDeSemana
	^ diaDeSemana! !

!Curso methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 15:53'!
diaDeSemana: anObject
	diaDeSemana := anObject! !

!Curso methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:47'!
docentes
	^ docentes! !

!Curso methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:47'!
docentes: anObject
	docentes := anObject! !

!Curso methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 15:53'!
fechaFin
	^ fechaFin! !

!Curso methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 15:53'!
fechaFin: anObject
	fechaFin := anObject! !

!Curso methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 15:53'!
fechaInicio
	^ fechaInicio! !

!Curso methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 15:53'!
fechaInicio: anObject
	fechaInicio := anObject! !

!Curso methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 15:53'!
horaFin
	^ horaFin! !

!Curso methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 15:53'!
horaFin: anObject
	horaFin := anObject! !

!Curso methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 15:53'!
horaInicio
	^ horaInicio! !

!Curso methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 15:53'!
horaInicio: anObject
	horaInicio := anObject! !

!Curso methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 15:50'!
metrosCuadradosMinimosDePizarron
	^ metrosCuadradosMinimosDePizarron! !

!Curso methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 15:50'!
metrosCuadradosMinimosDePizarron: anObject
	metrosCuadradosMinimosDePizarron := anObject! !

!Curso methodsFor: 'Domain' stamp: 'JulianGalati 9/30/2013 03:15'!
obtenerCursadas 
	
	"Ramiro: Para no devolver vaco. No me gusta tocar el getter."
	
	|listaDeCursadas|
	
	listaDeCursadas := Bag new.
	cursadas do:[ :unaCursada | listaDeCursadas add: unaCursada ].
	^listaDeCursadas.
	! !

!Curso methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 15:50'!
recursos
	^ recursos! !

!Curso methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 15:50'!
recursos: anObject
	recursos := anObject! !

Object subclass: #Docente
	uses: EstadisticasPorObjeto + EstadisticasPorAnio - {#filtrarAbandono:. #filtrarAprobados:. #filtrarPresentes:} + Agenda
	instanceVariableNames: 'cursos nombre grupos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1'!

Docente class
	uses: EstadisticasPorObjeto classTrait + EstadisticasPorAnio classTrait + Agenda classTrait
	instanceVariableNames: ''!

!Docente class methodsFor: 'Constructor' stamp: 'macha 9/13/2013 23:25'!
new: nombreDocente

	| unDocente |
	
	unDocente := Docente new.
	unDocente nombre: nombreDocente.
	unDocente cursos: Bag new.
	unDocente grupos: Bag new.
	
	^ unDocente.! !

!Docente methodsFor: 'Accessing' stamp: 'RamiroMachado 9/29/2013 21:35'!
agregarUnCurso: unCurso

	(self cursos) add: unCurso.! !

!Docente methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:48'!
cursos
	^ cursos! !

!Docente methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:48'!
cursos: anObject
	cursos := anObject! !

!Docente methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 12:24'!
grupos
	^ grupos! !

!Docente methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 12:24'!
grupos: anObject
	grupos := anObject! !

!Docente methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:48'!
nombre
	^ nombre! !

!Docente methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:48'!
nombre: anObject
	nombre := anObject! !

!Docente methodsFor: 'Domain' stamp: 'JulianGalati 9/30/2013 03:18'!
obtenerCursadas 
	
	
	|listaDeCursadas|
	
	listaDeCursadas := Bag new.
	cursos do:[:unCurso | listaDeCursadas := listaDeCursadas , unCurso obtenerCursadas].
	^listaDeCursadas.
	! !

!Docente methodsFor: 'Domain' stamp: 'JulianGalati 9/30/2013 03:19'!
obtenerNotasDeCursada: unAnio

	
	
	
	|listaDeCursadas|
	
	listaDeCursadas := Bag new.
	cursos do:[:unCurso | (unAnio = (unCurso anio))  ifTrue: [listaDeCursadas := listaDeCursadas , unCurso obtenerCursadas]].
	^listaDeCursadas.
	! !

Object subclass: #GrupoDeInvestigacion
	instanceVariableNames: 'integrantes actividades'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1'!

!GrupoDeInvestigacion class methodsFor: 'Constructor' stamp: 'JulianGalati 9/13/2013 12:33'!
new: listaDeIntegrantes

	|unGrupo|
	unGrupo:=GrupoDeInvestigacion new.
	unGrupo integrantes: listaDeIntegrantes.
	unGrupo actividades: Bag new.
	
	listaDeIntegrantes do: [ :unIntegrante | (unIntegrante grupos) add: unGrupo].	
	
	^ unGrupo.! !

!GrupoDeInvestigacion methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 11:41'!
actividades
	^ actividades! !

!GrupoDeInvestigacion methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 11:41'!
actividades: anObject
	actividades := anObject! !

!GrupoDeInvestigacion methodsFor: 'Domain' stamp: 'JulianGalati 9/13/2013 12:39'!
actividadesAunNoAprobadas

	^(actividades select: [ :unaActividad | (unaActividad aprobada) not]).
	! !

!GrupoDeInvestigacion methodsFor: 'Accessing' stamp: 'RamiroMachado 9/29/2013 22:11'!
agregarActividad: unaActividad

	(self actividades) add: unaActividad.
! !

!GrupoDeInvestigacion methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 12:42'!
agregarIntegrante: unIntegrante

	integrantes add: unIntegrante.
	unIntegrante grupos add: self.
! !

!GrupoDeInvestigacion methodsFor: 'Domain' stamp: 'JulianGalati 9/13/2013 12:04'!
articulosYSusFechasDeLosProyectos

	|articulos|
	
	articulos := Bag new.

	(actividades do:  [:unaActividad |  articulos := (articulos,(unaActividad decimeTusArticulos))]).
	
	^articulos.
	! !

!GrupoDeInvestigacion methodsFor: 'Domain' stamp: 'macha 9/13/2013 23:51'!
dameTusEventos: unIntegrante

	|listaDeEventos|
	
	listaDeEventos := OrderedCollection  new.
	
	( actividades do: [ :unaActividad | (unaActividad integranteEsta: unIntegrante)
		ifTrue: [ listaDeEventos add: (unaActividad decimeTusEventos)]] ).
	
	^listaDeEventos.! !

!GrupoDeInvestigacion methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 11:41'!
integrantes
	^ integrantes! !

!GrupoDeInvestigacion methodsFor: 'Accessing' stamp: 'JulianGalati 9/13/2013 11:41'!
integrantes: anObject
	integrantes := anObject! !

!GrupoDeInvestigacion methodsFor: 'Domain' stamp: 'JulianGalati 9/13/2013 11:49'!
montoTotalDeActividadesAunNoAprobadas

	^((self actividadesAunNoAprobadas) sum: [ :unaActividad | unaActividad monto]).
	! !

Object subclass: #Materia
	uses: EstadisticasPorObjeto
	instanceVariableNames: 'cursos nombre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1'!

Materia class
	uses: EstadisticasPorObjeto classTrait
	instanceVariableNames: ''!

!Materia class methodsFor: 'Constructor' stamp: 'macha 9/11/2013 10:11'!
new: nombreMateria

	| unaMateria |
	
	unaMateria := Materia new.
	unaMateria nombre: nombreMateria.
	unaMateria cursos: Bag new.
	^ unaMateria.! !

!Materia methodsFor: 'Accessing' stamp: 'RamiroMachado 9/29/2013 21:25'!
agregarUnCurso: unCurso

	(self cursos) add: unCurso.! !

!Materia methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:48'!
cursos
	^ cursos! !

!Materia methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:48'!
cursos: anObject
	cursos := anObject! !

!Materia methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:48'!
nombre
	^ nombre! !

!Materia methodsFor: 'Accessing' stamp: 'macha 9/11/2013 09:48'!
nombre: anObject
	nombre := anObject! !

!Materia methodsFor: 'Domain' stamp: 'JulianGalati 9/30/2013 03:17'!
obtenerCursadas

	|listaDeCursadas|
	
	listaDeCursadas := Bag new.
	
	cursos do: [ :unCurso | listaDeCursadas := (unCurso  obtenerCursadas , listaDeCursadas)].
	
	^ listaDeCursadas.! !
